#!/usr/bin/python3

class MyList:
    class MyListNode:
        def __init__(self, value=None, p=None, n=None):
            self.prev = p or self
            self.next = n or self
            self.value = value

    def __init__(self, iterable=None):
        self.head = self.MyListNode()
        for value in iterable or []:
            self.insert_tail(value)

    def insert_tail(self, value):
        self.__insert(value, self.head.prev, self.head)

    def insert_head(self, value):
        self.__insert(value, self.head, self.head.next)

    def __insert(self, value, p, n):
        new = self.MyListNode(value, p, n)
        p.next, n.prev = new, new

    class MyListIterator:
        def __init__(self, mylist):
            self.head = mylist.head;
            self.pos = mylist.head.next

        def __iter__(self):
            return self

        def __next__(self):
            if self.pos == self.head:
                raise StopIteration
            value = self.pos.value
            self.pos = self.pos.next
            return value

    def __iter__(self):
        return self.MyListIterator(self)

def main():
    l = MyList([1, 2, 3, 4])
    for value in l:
        print(value)

    l.insert_head(0)
    for value in l:
        print(value)

if __name__ == '__main__':
    main()
