#!/usr/bin/python3

class MetaLog(type):
    def __call__(self, *args, **kwargs):
        print("Create object with args:", self._make_args(*args, **kwargs))
        return super().__call__(*args, **kwargs)

    @staticmethod
    def _make_args(*args, **kwargs):
        pos_args = [str(arg) for arg in args]
        kw_args = ['{}={}'.format(k, repr(v)) for k, v in kwargs.items()]
        return ', '.join(pos_args + kw_args)


def main():
    class MyClass(metaclass=MetaLog):
        def __init__(self, *args, **kwargs):
            pass

    a = MyClass(a=True, b=False)
    b = MyClass(a=False, b=True)

if __name__ == '__main__':
    main()
