#!/usr/bin/python3

class MyDict:
    def __init__(self, pairs):
        self.store = {}
        for k, v in pairs:
            self.store[k] = v

    def __getitem__(self, key):
        return self.store[key]

    def __setitem__(self, key, value):
        self.store[key] = value

    def __delitem__(self, key):
        del self.store[key]

    def __contains__(self, key):
        return key in self.store

    def __iter__(self):
        return iter(self.store)

def main():
    d = MyDict(((k, str(k)) for k in range(10)))
    print('d[8] =', d[8])
    print('10 not in d =', 10 not in d)
    print('1 not in d =', 1 not in d)
    print('2 in d =', 2 in d)

if __name__ == '__main__':
    main()
